#ifndef EXAMPLE1_H
#define EXAMPLE1_H

#include <iostream>
#include <string>
#include "ObjectFactory.h"



// These are the unique identifiers for monster classes.  The object factory
// uses these to create the proper class type.
enum MONSTERS
{
   OGRE_MONSTER,
   GOBLIN_MONSTER,
};


// Our base monster class
class Monster
{
public:
   virtual ~Monster() {}
};


// These are our concrete monster classes that we'll be creating using the
// object factory.  They really don't do anything other than tell the user
// when they are created
class OgreMonster : public Monster
{
public:
   OgreMonster(float x, float y, float z)
   {
      std::cout << "Ogre monster created at coordinate: " << x << ", " << y << ", " << z << std::endl;
   }
};

class GoblinMonster : public Monster
{
public:
   GoblinMonster(float x, float y, float z)
   {
      std::cout << "Goblin monster created at coordinate: " << x << ", " << y << ", " << z << std::endl;
   }
};


#endif